﻿'Version 0.47 build 2021-03-30 beta
'Coded by UEZ

#Ifdef __Fb_64bit__
   #Inclib "gdiplus"
   #Include Once "win/gdiplus-c.bi"
#Else
   #Include Once "win/gdiplus.bi"
   Using Gdiplus
#Endif
#Include "Bass2.bi"
#Include "WinHTTP.bi"
#Include "String.bi"
#include "fbthread.bi"
#Include "boingball_64x64.bas"

Dim As String sCoder = "Coded by UEZ v0.47 build 2021-03-30 beta "
Dim Shared As String sRadioSite
sRadioSite = "amigaremix.com"

#Define DirExists(sPath)	(GetFileAttributes(sPath) = FILE_ATTRIBUTE_DIRECTORY)

Union uCol
	Dim As Ulong bgr
	Type
		As Ubyte r, g, b, a
	End Type
End Union

Dim Shared gdipToken As ULONG_PTR
Dim Shared GDIp As GdiplusStartupInput 
Dim Shared As QWORD iBytesLen, iEnd, iFilePosStart, iFilePos, iFileSize, iSongs
Dim Shared As String sRedirectURL, SOUNDFILE, sPlaying
Dim Shared As Ubyte iCounter = 0, iFGCol = 15, iBGCol = 4
Dim Shared As Double length
Dim Shared As Single vol = 0.15, iW, iH, fDPI
Dim Shared As Ubyte iOrder = 0, iDLFinished
Dim Shared As Ushort iNumber, iPosCursor, iConsoleW, iConsoleH
Dim Shared As Any Ptr hSession, hConnect, hImage, hConsole
Dim Shared As Integer cw2, ch2
Dim Shared As _CONSOLE_FONT_INFOEX fi2
Dim Shared As HBITMAP hBitmap
Dim Shared As HWND hGUI_logo, hPic_logo
Dim Shared As GUID tFrameDimList 
Dim Shared As Ulong iFrame = 0, iFrameDimCount, iFrames
Dim Shared As uCol col

Randomize

Function SearchInCMDArgument(sSearchFor as string) as ubyte
	Dim As Ubyte i = 1
	Do
		If Command(i) = sSearchFor Then Return i
		i += 1
	Loop While Len(Command(i)) > 0
	Return 0
End Function

'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
'https://docs.microsoft.com/en-us/windows/console/

Function GetFontInfo() As _CONSOLE_FONT_INFOEX
	Dim As _CONSOLE_FONT_INFOEX fi
	fi.cbSize = Sizeof(CONSOLE_FONT_INFOEX)
	GetCurrentConsoleFontEx(GetStdHandle(STD_OUTPUT_HANDLE), False, @fi)
	Return fi
End Function

Sub SetFontSize(w As Long, h As Long, ftype As String = "Consolas", nfont As DWORD = 0, nFontWeight As Uinteger = 800, nFontFamily As Uinteger = 0)
    Dim As _CONSOLE_FONT_INFOEX  x
    With x
        .cbsize = Sizeof(_CONSOLE_FONT_INFOEX)
        .nfont = nFont
        .dwfontsize = Type(w, h)
        .fontfamily = nFontFamily
        .fontweight = nFontWeight
        .facename = ftype
    End With
    SetCurrentConsoleFontEx(GetStdHandle(STD_OUTPUT_HANDLE), 1, @x)
End Sub

Sub GetConsoleSize(Byref w As Integer, Byref h As Integer)
	Dim As CONSOLE_SCREEN_BUFFER_INFO info
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), @info)
	w = info.srWindow.Right - info.srWindow.Left
	h = info.srWindow.Bottom - info.srWindow.Top
End Sub

Sub SetConsoleSize(cols As Long, lines As Long)
    Shell "MODE CON: COLS=" + Str(cols) + "LINES=" + Str(lines)
End Sub

'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function Replace (Byval buffer As String, Byval oldstring As String, Byval newstring As String) As String
    If Instr(buffer, oldstring) = 0 Then Return buffer   
    buffer = Chr(32) + buffer + Chr(32)
    
    Dim rep As Ubyte
    Dim SS As Integer
    Dim SE As Integer
    
    Do
        rep = 0
        If Instr(buffer, oldstring) > 0 Then
            rep = 1
            
            SS = Instr(buffer, oldstring) - 1
            SE = SS + Len(oldstring) + 1
            
            SS = Iif (SS < 1, 1, SS)
            SE = Iif (SE > Len(buffer), Len(buffer), SE)
            
            buffer = Mid(buffer, 1, SS) + newstring + Mid(buffer, SE, Len(buffer) - (SE - 1))
        End If

    Loop While rep = 1
    
    Return Trim(buffer)
End Function

'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function _GDIPlus_Startup() As Bool
	GDIp.GdiplusVersion = 1
	If GdiplusStartup(@gdipToken, @GDIp, NULL) <> 0 Then
		Error 1
		Return False
	Endif
	Return True
End Function

Sub _GDIPlus_Shutdown()
	GdiplusShutdown(gdipToken)
End Sub

'decode animated GIF and select frame 
Function _GDIPlus_GIFAnimGetFrameDimensionsCount(hImage As Any Ptr) As Ulong
	Dim As Ulong iFrameDimCount
	GdipImageGetFrameDimensionsCount(hImage, @iFrameDimCount)
	Return iFrameDimCount
End Function

Function _GDIPlus_GIFAnimGetFrameDimensionsList(hImage As Any Ptr, iFrameDimCount As Ulong) As GUID
	Dim As GUID FrameDimList
	GdipImageGetFrameDimensionsList(hImage, @FrameDimList, iFrameDimCount)
	Return FrameDimList
End Function

Function _GDIPlus_GIFAnimGetFrameCount(hImage As Any Ptr, tFrameDimList As GUID) As Ulong
	Dim As Ulong iFrameCount
	GdipImageGetFrameCount(hImage, @tFrameDimList, @iFrameCount)
	Return iFrameCount
End Function

Sub _GDIPlus_GIFAnimSelectActiveFrame(hImage As Any Ptr, tFrameDimList As GUID, iCurrentFrame As Ulong)
	GdipImageSelectActiveFrame(hImage, @tFrameDimList, iCurrentFrame)
End Sub

Function _GDIPlus_ImageGetPropertyItem(hImage As Any Ptr, iPropID As PROPID) As PropertyItem Ptr
	Dim As Ulong iSize
	GdipGetPropertyItemSize(hImage, iPropID, @iSize)
	Dim As PropertyItem Ptr buffer
	buffer = Allocate(iSize * SizeOf(PropertyItem))
	GdipGetPropertyItem(hImage, iPropID, iSize, @buffer[0])
	Return buffer
End Function

Function _GDIPlus_BitmapCreateFromMemory3(aBinImage As Ubyte Ptr, iLen As Ulong, bBitmap_GDI As Bool = False, iCol_GDI As Ulong = &hFF000000) As Any Ptr
   Dim As HGLOBAL hGlobal
   Dim As LPSTREAM hStream
   Dim As Any Ptr hImage_Stream
   Dim As Any Ptr hMemory = GlobalAlloc(GMEM_MOVEABLE, iLen)
   Dim As Any Ptr lpMemory = GlobalLock(hMemory)
   RtlCopyMemory(lpMemory, @aBinImage[0], iLen)
   GlobalUnlock(hMemory)
   CreateStreamOnHGlobal(hMemory, 0, @hStream)
   GdipCreateBitmapFromStream(hStream, @hImage_Stream)
   IUnknown_Release(hStream)

   If bBitmap_GDI = TRUE Then
      Dim hImage_GDI As Any Ptr
      GdipCreateHBITMAPFromBitmap(hImage_Stream, @hImage_GDI, iCol_GDI)
      GdipDisposeImage(hImage_Stream)
      Return hImage_GDI
   Endif

   Return hImage_Stream
End Function

Function WndProc(hWnd As HWND,uMsg As UINT,wParam As WPARAM,lParam As LPARAM) As Integer
	Select Case uMsg
		Case WM_CLOSE
			PostQuitMessage(0)	
'		Case WM_PAINT, WM_ERASEBKGND, WM_NCPAINT
'			SendMessage(hPic_logo, STM_SETIMAGE, IMAGE_BITMAP, Cast(LPARAM, hBitmap))
'			Return 0
	End Select
	Return DefWindowProc(hWnd, uMsg, wParam, lParam)
End Function

Sub Anim()		
	_GDIPlus_GIFAnimSelectActiveFrame(hImage, tFrameDimList, iFrame)
	DeleteObject(hBitmap)
	GdipCreateHBITMAPFromBitmap(hImage, @hBitmap, Rgba(col.r, col.g, col.b, 255))
	SendMessage(hPic_logo, STM_SETIMAGE, IMAGE_BITMAP, Cast(LPARAM, hBitmap))
	iFrame += 1
	iFrame = Iif(iFrame > iFrames - 1, 0, iFrame)
End Sub

Sub ChildGUI(param As Any Ptr)
	Dim szAppName As ZString * 10 => "FB GUI"
	Dim As String sTitle = ""
	Dim wc As WNDCLASSEX
	Dim msg As MSG
	With wc
		.style         = CS_HREDRAW Or CS_VREDRAW
		.lpfnWndProc   = @WndProc
		.cbClsExtra    = NULL
		.cbWndExtra    = NULL
		.hInstance     = GetModuleHandle(NULL)
		.hIcon         = LoadIcon(NULL, IDI_APPLICATION)
		.hCursor       = LoadCursor(NULL, IDC_ARROW)
		.hbrBackground = GetStockObject(BLACK_BRUSH)
		.lpszMenuName  = NULL
		.lpszClassName = @szAppName
		.cbSize			= SizeOf(WNDCLASSEX)
	End With
	 
	RegisterClassEx(@wc)
	
	hGUI_logo = CreateWindowEx(WS_EX_COMPOSITED, wc.lpszClassName, sTitle, _
							 WS_VISIBLE Or WS_POPUP Or WS_CLIPCHILDREN, _
							 (iConsoleW - 72) * 96 / fDPI, (iConsoleH - 72) * 96 / fDPI, _
							 64, 64, _
							 NULL, NULL, wc.hInstance, NULL)

	hPic_logo = CreateWindowEx(WS_EX_TRANSPARENT, "Static", "", WS_CHILD Or WS_VISIBLE Or SS_BITMAP Or WS_CLIPSIBLINGS, 0, 0, 64, 64, hGUI_logo, NULL, NULL, NULL)
	SetParent(hGUI_logo, hConsole)
	SetWindowPos(hGUI_logo, HWND_TOP, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW)
	SetWindowPos(hPic_logo, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOSIZE Or SWP_SHOWWINDOW)
	SetTimer(hGUI_logo, 1, 30, Cast(Any Ptr, @Anim))
	ShowWindow(hGUI_logo, SW_SHOWNOACTIVATE)
	
	SetActiveWindow(hConsole)
	SetFocus(hConsole)
	SetForegroundWindow(hConsole)
	
	While GetMessage(@msg, 0, 0, 0)
		TranslateMessage(@msg)
		DispatchMessage(@msg)
		Sleep(50)
	Wend	
End Sub

'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

'https://docs.microsoft.com/en-us/windows-hardware/drivers/ddi/content/ntifs/nf-ntifs-rtldecompressbufferex
Function _WinAPI_RtlDecompress(aBinary As Ubyte Ptr, iFileSize As Uinteger, iCompressedSize As Uinteger, iDecompressionEngine As Ushort = COMPRESSION_FORMAT_LZNT1) As Ubyte Ptr

    Dim As Any Ptr hLib = Dylibload("Ntdll.dll")

	Dim pRtlGetCompressionWorkSpaceSize As Function _
											(	Byval CompressionFormatAndEngine As Ushort, _
												Byval CompressBufferWorkSpaceSize As Uinteger Ptr, _
												Byval CompressFragmentWorkSpaceSize As Uinteger Ptr) As Ulong
											 
    Dim pRtlDecompressBufferEx As Function _
                                            (   Byval CompressionFormat As Ushort, _
                                                Byval UncompressedBuffer As Ubyte Ptr, _
                                                Byval UncompressedBufferSize As Uinteger, _
                                                Byval CompressedBuffer As Ubyte Ptr, _
                                                Byval CompressedBufferSize As Uinteger, _
                                                Byval FinalUncompressedSize As Uinteger Ptr, _
												Byval WorkSpace As Ubyte Ptr) As Uinteger
    
	pRtlGetCompressionWorkSpaceSize = Dylibsymbol(hLib, "RtlGetCompressionWorkSpaceSize")	
	pRtlDecompressBufferEx = Dylibsymbol(hLib, "RtlDecompressBufferEx")
	

    Dim As Uinteger iUSize, iDecompressBufferWorkSpaceSize, iDecompressFragmentWorkSpaceSize, iReturn
	iReturn = pRtlGetCompressionWorkSpaceSize(iDecompressionEngine, @iDecompressBufferWorkSpaceSize, @iDecompressFragmentWorkSpaceSize)
	Dim As Ubyte Ptr pWorkSpace = Allocate(iDecompressBufferWorkSpaceSize), pDecompress = Allocate(iFileSize)
	iReturn = pRtlDecompressBufferEx(iDecompressionEngine, pDecompress, iFileSize, aBinary, iCompressedSize, @iUSize, pWorkSpace)
	
	If iReturn Then
		? "An Error has occured:"
		Select Case iReturn
			Case &hC0000242
				? Hex(iReturn) & ": STATUS_BAD_COMPRESSION_BUFFER"
			Case &hC00000E8
				? Hex(iReturn) & ": STATUS_INVALID_USER_BUFFER"
			Case &hC000025F
				? Hex(iReturn) & ": STATUS_UNSUPPORTED_COMPRESSION"
			Case &hC000000D
				? Hex(iReturn) & ": STATUS_INVALID_PARAMETER"
			Case &h00000117
				? Hex(iReturn) & ": STATUS_BUFFER_ALL_ZEROS"
			Case &hC00000BB
				? Hex(iReturn) & ": STATUS_NOT_SUPPORTED"
			Case &hC0000023
				? Hex(iReturn) & ": STATUS_BUFFER_TOO_SMALL"
		End Select
	End If
	Deallocate(pWorkSpace)
    Dylibfree(hLib)
    Return pDecompress
End Function

Function Base128Decode(sString As String, Byref iBase128Len as Uinteger) As Ubyte Ptr
	If sString = "" Then 
		Error 1
		Return 0
	EndIf
	Dim As String sB128, sDecoded 
	sB128 = "!#$%()*,.0123456789:;=@ABCDEFGHIJKLMNOPQRSTUVWXYZ[]^_abcdefghijklmnopqrstuvwxyz{|}~¡¢£¤¥¦§¨©ª«¬®¯°±²³´µ¶·¸¹º»¼½¾¿ÀÁÂÃÄÅÆÇÈÉÊËÌÍÎ"
	Dim i As UInteger
	Dim aChr(0 To Len(sString)) As String
	For i = 0 To UBound(aChr)
		aChr(i) = Mid(sString, i + 1, 1)
	Next
	Dim As Long r, rs = 8, ls = 7, nc, r1
    
	For i = 0 To UBound(aChr) - 1
		nc = InStr(sB128, aChr(i)) - 1
		If rs > 7 Then
		   rs = 1
		   ls = 7
		   r = nc
		   Continue For
		EndIf
		r1 = nc
		nc = ((nc Shl ls) And &hFF) or r
		r = r1 Shr rs
		rs += 1
		ls -= 1
		sDecoded &= Chr(nc)
	Next
	iBase128Len = Len(sDecoded)
    
    'workaround For multiple embedded file other crash will occure
    Static As Ubyte aReturn(0 To iBase128Len - 1)
    Redim aReturn(0 To iBase128Len - 1) As Ubyte
	
	For i = 0 to Len(sDecoded) - 1 'convert result string to ascii code values
		aReturn(i) = Asc(sDecoded, i + 1)
	Next
	Return @aReturn(0) 'return pointer to the array
End Function

'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

Function GetLatestNumber() As Ushort
	Dim As Any Ptr hSession, hConnect, hRequest
	Dim As String sRead	
	hSession = _WinHttpOpen(WINHTTP_ACCESS_TYPE_DEFAULT_PROXY)
	If hSession = 0 Then ? "hSession = " & hSession
	hConnect = _WinHttpConnect(hSession, Wstr(sRadioSite))
	If hConnect = 0 Then ? "hConnect = " & hConnect
	hRequest = _WinHttpSimpleSendRequest(hConnect, "")
	If hRequest = 0 Then ? "hRequest = " & hRequest
	sRead = _WinHttpSimpleReadData(hRequest)
	_WinHttpCloseHandle(hRequest)
	_WinHttpCloseHandle(hConnect)
	_WinHttpCloseHandle(hSession)
	Sleep(100)
	'Dim As String aResult()
	'StringRegEx("(?m)\/listen\/(\d+?)\/", sRead, aResult())
	'If aResult(0) <> "" Then Return Valint(aResult(2))
	Dim As String sSearch = "<td class=" & Chr(34) & "c1" & Chr(34) & "><a href=" & Chr(34) & "/listen/"
	Dim As Long iLen = Len(sSearch), iPos = Instr(sRead, sSearch) + iLen, iLatestNumber = Valint(Mid(sRead, iPos, Instr(iPos, sRead, "/") - iPos))
	Return iLatestNumber
End Function

Sub CallBack_Redirect(hInternet As Any Ptr, dwContext As DWORD_PTR, dwInternetStatus As DWORD, lpvStatusInformation As Zstring Ptr, dwStatusInformationLength As DWORD)
	Dim As String sResult
	For i As Ulong = 0 To 2 * dwStatusInformationLength - 1
		sResult &= Str(*(@lpvStatusInformation[i]))
	Next
	iCounter += 1
	sRedirectURL = Replace(sResult, "%20", " ")
End Sub

Sub GetRedirectedFilename(iNumber As Ushort)
	Dim As Any Ptr hRequest
	Dim As String sRead
	_WinHttpSetStatusCallback(hConnect, @CallBack_Redirect, WINHTTP_CALLBACK_STATUS_REDIRECT)
	hRequest = _WinHttpSimpleSendRequest(hConnect, "listen/" & iNumber)
	_WinHttpCloseHandle(hRequest)
End Sub

Sub Download_CurrentSong(param As Any Ptr)
	Dim As String sSuffixURL = Mid(SOUNDFILE, Instr(SOUNDFILE, sRadioSite) + Len(sRadioSite))
	Dim As HINTERNET hRequest_Dl = _WinHttpOpenRequest(hConnect, "GET", sSuffixURL, "HTTP/1.1", WINHTTP_NO_REFERER, WINHTTP_DEFAULT_ACCEPT_TYPES, WINHTTP_FLAG_ESCAPE_DISABLE Or WINHTTP_FLAG_SECURE)
	If hRequest_Dl = 0 Then Exit Sub
	_WinHttpSendRequest(hRequest_Dl)
	If _WinHttpReceiveResponse(hRequest_Dl) Then
		Locate iPosCursor + 3, 0, 0
		Color iFGCol, iBGCol
		? "Downloading..."
		Dim As Ulong iNumberOfBytesRead, i, j = 0, iNumberOfBytesAvailable
		Dim As Ubyte aBinData(iFileSize), aBuffer
		Do
			iNumberOfBytesAvailable = 0
			If _WinHttpQueryDataAvailable(hRequest_Dl, @iNumberOfBytesAvailable) = 0 Then Exit Do
			If iNumberOfBytesAvailable = 0 Then Exit Do
			Redim aBuffer(iNumberOfBytesAvailable - 1)
			WinHttpReadData(hRequest_Dl, @aBuffer(0), iNumberOfBytesAvailable, @iNumberOfBytesRead)
			For i = 0 To Ubound(aBuffer)
				If j <= iFileSize Then aBinData(j) = aBuffer(i)
				j += 1
			Next
		Loop Until iNumberOfBytesAvailable = 0
		Dim As Long hFile = Freefile()
		Open Exepath & "\" & sRadioSite  & "\" & sPlaying For Binary Access Write As #hFile
		Put #hFile, 0, aBinData(0), iFileSize
		Close #hFile
	Endif
	_WinHttpCloseHandle(hRequest_Dl)	
	iDLFinished = 2
End Sub

Function Stream() As hStream
	Color iFGCol, iBGCol
	Shell "Cls"
	Locate 1, 0 
	Select Case iOrder
		Case 0
			iNumber = 1 + Cshort(Rnd * iSongs) '2404
		Case 1
			iNumber -= 1
		Case 2
			iNumber += 1
	End Select
	SOUNDFILE = "https://" & sRadioSite & "/listen/" & Str(iNumber)
	GetRedirectedFilename(iNumber)
	Sleep (100)
	? "URL:     " & SOUNDFILE
	sPlaying = Mid(sRedirectURL, Instrrev(sRedirectURL, "/") + 1)
	? "Playing: " & sPlaying
	Dim As HSTREAM hStream = _BASS_StreamCreateURL(SOUNDFILE)
	iBytesLen = _BASS_ChannelGetLength(hStream)
	iFileSize = _BASS_StreamGetFilePosition(hStream, BASS_FILEPOS_SIZE)
	iFilePosStart = _BASS_StreamGetFilePosition(hStream, BASS_FILEPOS_START)
	? "Size:    " & iFileSize & " bytes"
	length = _BASS_ChannelBytes2Seconds(hStream, iBytesLen)
	? Using "Length: ####.## seconds"; length
	iEnd = BASS_StreamGetFilePosition(hStream, BASS_FILEPOS_END)
	_BASS_ChannelSetAttribute(hStream, BASS_ATTRIB_VOL, vol)
	_BASS_ChannelPlay(hStream)
	SendMessage(hPic_logo, STM_SETIMAGE, IMAGE_BITMAP, Cast(LPARAM, hBitmap))
	Return HSTREAM
End Function

'-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

If _GDIPlus_Startup() = False Then End 4
Dim as Any Ptr hGfx
GdipCreateFromHWND(0, @hGfx)
GdipGetDpiX(hGfx, @fDPI)
GdipDeleteGraphics(hGfx)

? "Initializing WinHTTP..."
If _WinHttpStartup() = False Then ? "Unable To initialize Winhttp.dll! Exiting..." : End 1
? "Initializing Bass.dll..."
If _Bass_Startup(Exepath) = False Then ? "Unable To initialize Bass.dll! Exiting..." : End 2
? "Getting latest song number..."
hSession = _WinHttpOpen(WINHTTP_ACCESS_TYPE_NO_PROXY)
hConnect = _WinHttpConnect(hSession, Wstr(sRadioSite))
iSongs = GetLatestNumber()
If iSongs = 0 Then ? "Unable To Get latest song number! Exiting..." : End 3

Dim As Ubyte iPos = SearchInCMDArgument("/order") 
If iPos And Len(Command(iPos + 1)) > 0 Then 
	iOrder = ValInt(Command(iPos + 1))
	iOrder = Iif(iOrder > 2, 0, iOrder)
Endif

Select Case iOrder
	Case 1 'play from latest to oldest
		iNumber = iSongs + 1
	Case 2 'play from oldest to latest
		iNumber = 0
End Select

_Bass_Init()


Dim as Any Ptr hStdOut = GetStdHandle(STD_OUTPUT_HANDLE)
hConsole = GetConsoleWindow()
Dim As Integer cw, ch
GetConsoleSize(cw, ch)
Dim As _CONSOLE_FONT_INFOEX fi = GetFontInfo()
Dim As Zstring * 255 sTitle
GetConsoleTitle(sTitle, 255)
Dim As CONSOLE_SCREEN_BUFFER_INFO buffinfo
GetConsoleScreenBufferInfo(hStdOut, @buffinfo)

SetConsoleTitle("Radio Station " & sRadioSite & " / ~" & iSongs & " songs available")
Dim As Ubyte iFsW = 8, iFsH = 12, iCsW = 90, iCsH = 8

SetFontSize(iFsW * fDPI / 96, iFsH * fDPI / 96)
SetConsoleSize(iCsW, iCsH)
iConsoleW = iFsW * iCsW
iConsoleH = iFsH * iCsH
fi2 = GetFontInfo()
GetConsoleSize(cw2, ch2)

Dim As Any Ptr hSysMenu = GetSystemMenu(hConsole, False)
SetWindowLong(hConsole, GWL_STYLE, GetWindowLong(hConsole, GWL_STYLE) And Not WS_MAXIMIZEBOX And Not WS_SIZEBOX) 'grey Out maximize icon And disable resizing
EnableMenuItem(hSysMenu, SC_CLOSE, MF_BYCOMMAND Or MF_DISABLED Or MF_GRAYED) 'grey Out Close icon

Dim As HSTREAM hStream = Stream()

Dim As QWORD iCurrentPos
Dim As Double t1, p = 0
Dim As Any Ptr thread, threadGUI
Dim As Integer bPause = 0, r = 1
Dim As BASS_LEVELS Levels
Dim As Ubyte aColorsBg(...) = {iBGCol, iBGCol, 1, 3, 9, 11, 7, 15},  aColorsFg(...) = {15, 15, 15, 14, 14, 13, 5, 1}, iUB = Ubound(aColorsFg), iLevel
Dim As String sec, mins, hr, ms
Dim As Single br

'GdipLoadImageFromFile(Exepath & "\C64_2.png", @hImage)
Dim As UInteger iLines, iCompression, iFileSize2, iCompressedSize
Dim As String sBaseType, sBase128, aB128(1)

Restore __Label0:
Read iLines
Read iCompression
Read iFileSize2
Read iCompressedSize
Read sBaseType

For i As Ushort = 0 To iLines - 1
   Read aB128(0)
   sBase128 &= aB128(0)
Next

Dim As UInteger l 
Dim As Ubyte Ptr aBinary = Base128Decode(sBase128, l)
hImage = _GDIPlus_BitmapCreateFromMemory3(aBinary, iFileSize2)

iFrameDimCount = _GDIPlus_GIFAnimGetFrameDimensionsCount(hImage)
tFrameDimList = _GDIPlus_GIFAnimGetFrameDimensionsList(hImage, iFrameDimCount)
iFrames = _GDIPlus_GIFAnimGetFrameCount(hImage, tFrameDimList)
GdipGetImageDimension(hImage, @iW, @iH)
aBinary = 0
sBase128 = ""

Dim As HDC dc = GetDC(hConsole)

col.bgr = GetPixel(dc, 0, 0) 'bgr
ReleaseDC(hConsole, dc)
	
threadGUI = ThreadCreate(@ChildGUI, 0)
Sleep(100)

iPosCursor = Csrlin

While True
	Locate iPosCursor, 1, 0
	Select Case Inkey()
		Case Chr(27), Chr(113) 'ESC or q to exit program
			Exit While
		Case Chr(32) 'skip current song And load Next one
			While Inkey() = Chr(32)
				Sleep (5)
			Wend
			_BASS_ChannelStop(hStream)
			_BASS_StreamFree(hStream)
			hStream = Stream()
			iBytesLen = _BASS_ChannelGetLength(hStream)
		Case Chr(8) 'backspace To play again
			While Inkey() = Chr(8)
				Sleep (5)
			Wend
			'_BASS_ChannelStop(hStream)
			_BASS_ChannelSetPosition(hStream, 0, BASS_POS_BYTE Or BASS_POS_SCAN)
			'_BASS_ChannelPlay(hStream)
		Case Chr(112) 'press p To pause / Resume stream
			While Inkey() = Chr(112)
				Sleep (5)
			Wend
			If bPause = 0 Then 
				_BASS_ChannelPause(hStream)
				bPause = 1
			Else
				_BASS_ChannelPlay(hStream, False)
				bPause = 0
			End If
		Case Chr(43) '+ To increase volume
			While Inkey() = Chr(43)
				Sleep (5)
			Wend		
			If vol <= 1.0 Then vol += 0.05
			_BASS_ChannelSetAttribute(hStream, BASS_ATTRIB_VOL, vol)
		Case Chr(45) '- To decrease volume
			While Inkey() = Chr(45)
				Sleep (5)
			Wend
			If vol > 0.05 Then vol -= 0.05
			_BASS_ChannelSetAttribute(hStream, BASS_ATTRIB_VOL, vol)
		Case Chr(48) '0 to play randomly a song
			While Inkey() = Chr(48)
				Sleep (5)
			Wend
			iOrder = 0
			_BASS_ChannelStop(hStream)
			_BASS_StreamFree(hStream)
			hStream = Stream()
			iBytesLen = _BASS_ChannelGetLength(hStream)	
		Case Chr(49) '1 to play from latest to oldest
			While Inkey() = Chr(49)
				Sleep (5)
			Wend
			iOrder = 1
			iNumber = iSongs + 1
			_BASS_ChannelStop(hStream)
			_BASS_StreamFree(hStream)
			hStream = Stream()
			iBytesLen = _BASS_ChannelGetLength(hStream)		
		Case Chr(100)
			While Inkey() = Chr(100)
				Sleep (5)
			Wend
			If DirExists(Exepath & "\" & sRadioSite) = 0 Then Mkdir Exepath & "\" & sRadioSite
			If iDLFinished = 0 Then
				thread = ThreadCreate(@Download_CurrentSong, 0)
				iDLFinished = 1
			Endif
	End Select
	_BASS_ChannelGetLevelEx(hStream, Levels, 0.02, BASS_LEVEL_MONO)
	iCurrentPos = _BASS_ChannelGetPosition(hStream, BASS_POS_BYTE) 
	p = _BASS_ChannelBytes2Seconds(hStream, iCurrentPos)

	Color iFGCol, iBGCol
	'? Using "Played: ###.## % / ###.## s"; iCurrentPos / iBytesLen * 100; length - p
	ms = Format(Frac(p) * 1000, "000")
	sec = Format(p Mod 60, "00")
	mins = Format(p \ 60, "00")
	hr = Format(p \ 3600, "00")

	? "Played:  " & Format(iCurrentPos / iBytesLen, "00.00 % / ") & Format (length - p, "##0.00 s / ") & hr & ":" & mins & ":" & sec & ":" & ms & " / volume: " & Cubyte(vol * 100) & "       "
	Locate iPosCursor + 2, 0, 0
	iLevel = Levels.Left * iUB
	Color aColorsFg(iLevel), aColorsBg(iLevel) ', 6 'aColors(6 - (Levels.Left + Levels.Right) * 6)
'	? "                                                                               "
'	Locate iPosCursor + 2, p, 0
'	p += 0.1 * r
'	If Int(p) < 0 Or Int(p) > 39 Then r *= -1
	? sCoder
	If (iCurrentPos >= iBytesLen) Or (iFileSize - iFilePosStart - _BASS_StreamGetFilePosition(hStream, BASS_FILEPOS_CURRENT) <= 0) Then  
		_BASS_ChannelStop(hStream)
		_BASS_StreamFree(hStream)
		hStream = Stream()
		iBytesLen = _BASS_ChannelGetLength(hStream)
	End If
	If iDLFinished = 2 Then
		ThreadDetach(thread)
		iDLFinished = 0
		Locate iPosCursor + 3, 0, 0
		Color iFGCol, iBGCol
		? "                            "
	End If
	Sleep(15)
Wend

Killtimer(hGUI_logo, 1)
DestroyWindow(hGUI_logo)
ThreadDetach(threadGUI)

_BASS_ChannelStop(hStream)
_BASS_StreamFree(hStream)
_Bass_Free()
_Bass_Shutdown()

_WinHttpCloseHandle(hConnect)
_WinHttpCloseHandle(hSession)
_WinHttpShutdown()

DeleteObject(hBitmap)
GdipDisposeImage(hImage)
_GDIPlus_Shutdown()

'Restore console settings
SetWindowLong(hConsole, GWL_STYLE, GetWindowLong(hConsole, GWL_STYLE) Or WS_MAXIMIZEBOX Or WS_SIZEBOX)
EnableMenuItem(hSysMenu, SC_CLOSE, MF_BYCOMMAND Or MF_ENABLED)
SetConsoleTextAttribute(hStdOut, buffinfo.wAttributes)

SetConsoleTitle(sTitle)
SetConsoleSize(cw, ch)
SetFontSize(fi.dwFontSize.x, fi.dwFontSize.y, fi.facename, fi.nFont, fi.FontWeight, fi.FontFamily)

Shell "Cls"
? "Bye...."
End 0